Loading...
Searching...
No Matches
casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator > Class Template Reference

QuantileComputer used by HingesFencesStatistics for computing quantile-like statistics. More...

`#include <HingesFencesQuantileComputer.h>`

## Public Member Functions

| HingesFencesQuantileComputer ()=delete
| HingesFencesQuantileComputer (StatisticsDataset< CASA_STATP > *dataset)
| HingesFencesQuantileComputer (const HingesFencesQuantileComputer &other)
| copy semantics
virtual | ~HingesFencesQuantileComputer ()
HingesFencesQuantileComputer & | operator= (const HingesFencesQuantileComputer &other)
| copy semantics
virtual StatisticsAlgorithmQuantileComputer< CASA_STATP > * | clone () const
| clone this object by returning a pointer to a copy
virtual void | reset ()
| reset private fields
void | setHasRange (Bool hr)
Public Member Functions inherited from casacore::ConstrainedRangeQuantileComputer< CASA_STATP >
| ConstrainedRangeQuantileComputer ()=delete
virtual | ~ConstrainedRangeQuantileComputer ()
ConstrainedRangeQuantileComputer & | operator= (const ConstrainedRangeQuantileComputer &other)
| copy semantics
virtual CASA_STATP | getMedian (uInt64 mynpts, CASA_STATP mymin, CASA_STATP mymax, uInt binningThreshholdSizeBytes, Bool persistSortedArray, uInt nBins)
| Caller is responsible for passing correct values of mynpts, mymin, and mymax; no checking is done for correctness in this method.
virtual CASA_STATP | getMedianAbsDevMed (uInt64 mynpts, CASA_STATP mymin, CASA_STATP mymax, uInt binningThreshholdSizeBytes, Bool persistSortedArray, uInt nBins)
| get the median of the absolute deviation about the median of the data.
void | setRange (const std::pair< CASA_STATP, CASA_STATP > &r)
Public Member Functions inherited from casacore::ClassicalQuantileComputer< CASA_STATP >
| ClassicalQuantileComputer ()=delete
virtual | ~ClassicalQuantileComputer ()
ClassicalQuantileComputer & | operator= (const ClassicalQuantileComputer &other)
| copy semantics
virtual CASA_STATP | getMedianAndQuantiles (std::map< Double, CASA_STATP > &quantiles, const std::set< Double > &fractions, uInt64 mynpts, CASA_STATP mymin, CASA_STATP mymax, uInt binningThreshholdSizeBytes, Bool persistSortedArray, uInt nBins)
| If one needs to compute both the median and QuantileComputer values, it is better to call getMedianAndQuantiles() rather than getMedian() and getQuantiles() separately, as the first will scan large data sets fewer times than calling the separate methods.
virtual std::map< Double, CASA_STATP > | getQuantiles (const std::set< Double > &fractions, uInt64 mynpts, CASA_STATP mymin, CASA_STATP mymax, uInt binningThreshholdSizeBytes, Bool persistSortedArray, uInt nBins)
| Get the specified Quantiles.
Public Member Functions inherited from casacore::StatisticsAlgorithmQuantileComputer< CASA_STATP >
| StatisticsAlgorithmQuantileComputer ()=delete
virtual | ~StatisticsAlgorithmQuantileComputer ()
void | deleteSortedArray ()
| delete any (partially) sorted array
void | setDataset (StatisticsDataset< CASA_STATP > *ds)
| This must be called upon the copy or assignment of the associated statistics algorithm object.
std::vector< CASA_STATP > & | _getSortedArray ()
| FIXME make protected once refactor is complete.
void | _setSortedArray (const std::vector< CASA_STATP > &v)
| FIXME make protected once refactor is complete.
void | setMedian (std::shared_ptr< CASA_STATP > median)

## Protected Member Functions

virtual void | _findBins (std::vector< BinCountArray > &binCounts, std::vector< std::shared_ptr< AccumType > > &sameVal, std::vector< Bool > &allSame, const DataIterator &dataBegin, uInt64 nr, uInt dataStride, const std::vector< StatsHistogram< AccumType > > &binDesc, const std::vector< AccumType > &maxLimit) const
virtual void | _findBins (std::vector< BinCountArray > &binCounts, std::vector< std::shared_ptr< AccumType > > &sameVal, std::vector< Bool > &allSame, const DataIterator &dataBegin, uInt64 nr, uInt dataStride, const DataRanges &ranges, Bool isInclude, const std::vector< StatsHistogram< AccumType > > &binDesc, const std::vector< AccumType > &maxLimit) const
virtual void | _findBins (std::vector< BinCountArray > &binCounts, std::vector< std::shared_ptr< AccumType > > &sameVal, std::vector< Bool > &allSame, const DataIterator &dataBegin, uInt64 nr, uInt dataStride, const MaskIterator &maskBegin, uInt maskStride, const std::vector< StatsHistogram< AccumType > > &binDesc, const std::vector< AccumType > &maxLimit) const

virtual void

_findBins (std::vector< BinCountArray > &binCounts, std::vector< std::shared_ptr< AccumType > > &sameVal, std::vector< Bool > &allSame, const DataIterator &dataBegin, uInt64 nr, uInt dataStride, const MaskIterator &maskBegin, uInt maskStride, const DataRanges &ranges, Bool isInclude, const std::vector< StatsHistogram< AccumType > > &binDesc, const std::vector< AccumType > &maxLimit) const

virtual void | _findBins (std::vector< BinCountArray > &binCounts, std::vector< std::shared_ptr< AccumType > > &sameVal, std::vector< Bool > &allSame, const DataIterator &dataBegin, const WeightsIterator &weightsBegin, uInt64 nr, uInt dataStride, const std::vector< StatsHistogram< AccumType > > &binDesc, const std::vector< AccumType > &maxLimit) const
virtual void | _findBins (std::vector< BinCountArray > &binCounts, std::vector< std::shared_ptr< AccumType > > &sameVal, std::vector< Bool > &allSame, const DataIterator &dataBegin, const WeightsIterator &weightsBegin, uInt64 nr, uInt dataStride, const DataRanges &ranges, Bool isInclude, const std::vector< StatsHistogram< AccumType > > &binDesc, const std::vector< AccumType > &maxLimit) const

virtual void

_findBins (std::vector< BinCountArray > &binCounts, std::vector< std::shared_ptr< AccumType > > &sameVal, std::vector< Bool > &allSame, const DataIterator &dataBegin, const WeightsIterator &weightsBegin, uInt64 nr, uInt dataStride, const MaskIterator &maskBegin, uInt maskStride, const DataRanges &ranges, Bool isInclude, const std::vector< StatsHistogram< AccumType > > &binDesc, const std::vector< AccumType > &maxLimit) const

virtual void | _findBins (std::vector< BinCountArray > &binCounts, std::vector< std::shared_ptr< AccumType > > &sameVal, std::vector< Bool > &allSame, const DataIterator &dataBegin, const WeightsIterator &weightBegin, uInt64 nr, uInt dataStride, const MaskIterator &maskBegin, uInt maskStride, const std::vector< StatsHistogram< AccumType > > &binDesc, const std::vector< AccumType > &maxLimit) const
virtual void | _populateArray (DataArray &ary, const DataIterator &dataBegin, uInt64 nr, uInt dataStride) const
| populate an unsorted array with valid data.
virtual void | _populateArray (DataArray &ary, const DataIterator &dataBegin, uInt64 nr, uInt dataStride, const DataRanges &ranges, Bool isInclude) const
| ranges
virtual void | _populateArray (DataArray &ary, const DataIterator &dataBegin, uInt64 nr, uInt dataStride, const MaskIterator &maskBegin, uInt maskStride) const
virtual void | _populateArray (DataArray &ary, const DataIterator &dataBegin, uInt64 nr, uInt dataStride, const MaskIterator &maskBegin, uInt maskStride, const DataRanges &ranges, Bool isInclude) const
| mask and ranges
virtual void | _populateArray (DataArray &ary, const DataIterator &dataBegin, const WeightsIterator &weightsBegin, uInt64 nr, uInt dataStride) const
| weights
virtual void | _populateArray (DataArray &ary, const DataIterator &dataBegin, const WeightsIterator &weightsBegin, uInt64 nr, uInt dataStride, const DataRanges &ranges, Bool isInclude) const
| weights and ranges
virtual void | _populateArray (DataArray &ary, const DataIterator &dataBegin, const WeightsIterator &weightBegin, uInt64 nr, uInt dataStride, const MaskIterator &maskBegin, uInt maskStride) const
| weights and mask
virtual void | _populateArray (DataArray &ary, const DataIterator &dataBegin, const WeightsIterator &weightBegin, uInt64 nr, uInt dataStride, const MaskIterator &maskBegin, uInt maskStride, const DataRanges &ranges, Bool isInclude) const
| weights, mask, ranges
virtual void | _populateArrays (std::vector< DataArray > &arys, uInt64 &currentCount, const DataIterator &dataBegin, uInt64 nr, uInt dataStride, const IncludeLimits &includeLimits, uInt64 maxCount) const
| no weights, no mask, no ranges
virtual void | _populateArrays (std::vector< DataArray > &arys, uInt64 &currentCount, const DataIterator &dataBegin, uInt64 nr, uInt dataStride, const DataRanges &ranges, Bool isInclude, const IncludeLimits &includeLimits, uInt64 maxCount) const
| ranges
virtual void | _populateArrays (std::vector< DataArray > &arys, uInt64 &currentCount, const DataIterator &dataBegin, uInt64 nr, uInt dataStride, const MaskIterator &maskBegin, uInt maskStride, const IncludeLimits &includeLimits, uInt64 maxCount) const
virtual void | _populateArrays (std::vector< DataArray > &arys, uInt64 &currentCount, const DataIterator &dataBegin, uInt64 nr, uInt dataStride, const MaskIterator &maskBegin, uInt maskStride, const DataRanges &ranges, Bool isInclude, const IncludeLimits &includeLimits, uInt64 maxCount) const
| mask and ranges
virtual void | _populateArrays (std::vector< DataArray > &arys, uInt64 &currentCount, const DataIterator &dataBegin, const WeightsIterator &weightsBegin, uInt64 nr, uInt dataStride, const IncludeLimits &includeLimits, uInt64 maxCount) const
| weights
virtual void | _populateArrays (std::vector< DataArray > &arys, uInt64 &currentCount, const DataIterator &dataBegin, const WeightsIterator &weightsBegin, uInt64 nr, uInt dataStride, const DataRanges &ranges, Bool isInclude, const IncludeLimits &includeLimits, uInt64 maxCount) const
| weights and ranges
virtual void | _populateArrays (std::vector< DataArray > &arys, uInt64 &currentCount, const DataIterator &dataBegin, const WeightsIterator &weightBegin, uInt64 nr, uInt dataStride, const MaskIterator &maskBegin, uInt maskStride, const IncludeLimits &includeLimits, uInt64 maxCount) const
| weights and mask
virtual void | _populateArrays (std::vector< DataArray > &arys, uInt64 &currentCount, const DataIterator &dataBegin, const WeightsIterator &weightBegin, uInt64 nr, uInt dataStride, const MaskIterator &maskBegin, uInt maskStride, const DataRanges &ranges, Bool isInclude, const IncludeLimits &includeLimits, uInt64 maxCount) const
| weights, mask, ranges
virtual Bool | _populateTestArray (DataArray &ary, const DataIterator &dataBegin, uInt64 nr, uInt dataStride, uInt maxElements) const
| no weights, no mask, no ranges
virtual Bool | _populateTestArray (DataArray &ary, const DataIterator &dataBegin, uInt64 nr, uInt dataStride, const DataRanges &ranges, Bool isInclude, uInt maxElements) const
| ranges
virtual Bool | _populateTestArray (DataArray &ary, const DataIterator &dataBegin, uInt64 nr, uInt dataStride, const MaskIterator &maskBegin, uInt maskStride, uInt maxElements) const
| mask
virtual Bool | _populateTestArray (DataArray &ary, const DataIterator &dataBegin, uInt64 nr, uInt dataStride, const MaskIterator &maskBegin, uInt maskStride, const DataRanges &ranges, Bool isInclude, uInt maxElements) const
| mask and ranges
virtual Bool | _populateTestArray (DataArray &ary, const DataIterator &dataBegin, const WeightsIterator &weightBegin, uInt64 nr, uInt dataStride, uInt maxElements) const
| weights
virtual Bool | _populateTestArray (DataArray &ary, const DataIterator &dataBegin, const WeightsIterator &weightsBegin, uInt64 nr, uInt dataStride, const DataRanges &ranges, Bool isInclude, uInt maxElements) const
| weights and ranges
virtual Bool | _populateTestArray (DataArray &ary, const DataIterator &dataBegin, const WeightsIterator &weightBegin, uInt64 nr, uInt dataStride, const MaskIterator &maskBegin, uInt maskStride, uInt maxElements) const
| weights and mask
virtual Bool | _populateTestArray (DataArray &ary, const DataIterator &dataBegin, const WeightsIterator &weightBegin, uInt64 nr, uInt dataStride, const MaskIterator &maskBegin, uInt maskStride, const DataRanges &ranges, Bool isInclude, uInt maxElements) const
| weights, mask, ranges
Protected Member Functions inherited from casacore::ConstrainedRangeQuantileComputer< CASA_STATP >
virtual void | _findBins (std::vector< BinCountArray > &binCounts, std::vector< std::shared_ptr< CASA_STATP > > &sameVal, std::vector< Bool > &allSame, const DataIterator &dataBegin, uInt64 nr, uInt dataStride, const std::vector< StatsHistogram< CASA_STATP > > &binDesc, const std::vector< CASA_STATP > &maxLimit) const
Protected Member Functions inherited from casacore::ClassicalQuantileComputer< CASA_STATP >
virtual void | _findBins (std::vector< std::vector< uInt64 > > &binCounts, std::vector< std::shared_ptr< CASA_STATP > > &sameVal, std::vector< Bool > &allSame, const DataIterator &dataBegin, uInt64 nr, uInt dataStride, const std::vector< StatsHistogram< CASA_STATP > > &hist, const std::vector< CASA_STATP > &maxLimit) const
| Get the counts of data within the specified histogram bins.
virtual void | _populateArray (std::vector< CASA_STATP > &ary, const DataIterator &dataBegin, uInt64 nr, uInt dataStride) const
| populate an unsorted array with valid data.
virtual void | _populateArrays (std::vector< std::vector< CASA_STATP > > &arys, uInt64 &currentCount, const DataIterator &dataBegin, uInt64 nr, uInt dataStride, const IncludeLimits &includeLimits, uInt64 maxCount) const
| Create a std::vector of unsorted arrays, one array for each bin defined by includeLimits.
virtual Bool | _populateTestArray (std::vector< CASA_STATP > &ary, const DataIterator &dataBegin, uInt64 nr, uInt dataStride, uInt maxElements) const
| no weights, no mask, no ranges
Bool | _valuesFromSortedArray (std::map< uInt64, CASA_STATP > &values, uInt64 mynpts, const std::set< uInt64 > &indices, uInt64 maxArraySize, Bool persistSortedArray)
| get values from sorted array if the array is small enough to be held in memory.
Protected Member Functions inherited from casacore::StatisticsAlgorithmQuantileComputer< CASA_STATP >
StatisticsAlgorithmQuantileComputer & | operator= (const StatisticsAlgorithmQuantileComputer &other)
| use copy semantics.
StatisticsDataset< CASA_STATP > * | _getDataset ()
std::shared_ptr< CASA_STATP > | _getMedian () const
std::shared_ptr< CASA_STATP > | _getMedianAbsDevMedian () const
void | _setMedianAbsDevMedian (std::shared_ptr< CASA_STATP > medAbsDevMed)

## Private Attributes

Bool | _hasRange

## Detailed Description

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>
class casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >

QuantileComputer used by HingesFencesStatistics for computing quantile-like statistics.

API developers should never explicitly instantiate this class. See class documentation for StatisticsAlgorithm for details regarding QuantileComputer classes.

Definition at line 46 of file HingesFencesQuantileComputer.h.

## Constructor & Destructor Documentation

## HingesFencesQuantileComputer() [1/3]

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>

casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >::HingesFencesQuantileComputer | ( |  | ) |

delete

Referenced by HingesFencesQuantileComputer(), and operator=().

## HingesFencesQuantileComputer() [2/3]

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>

casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >::HingesFencesQuantileComputer | ( | StatisticsDataset< CASA_STATP > * | dataset | ) |

## HingesFencesQuantileComputer() [3/3]

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>

casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >::HingesFencesQuantileComputer | ( | const HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator > & | other | ) |

copy semantics

References HingesFencesQuantileComputer().

## ~HingesFencesQuantileComputer()

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>

virtual casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >::~HingesFencesQuantileComputer | ( |  | ) |

virtual

## Member Function Documentation

## _findBins() [1/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>

virtual void casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >::_findBins | ( | std::vector< BinCountArray > & | binCounts,
|  | std::vector< std::shared_ptr< AccumType > > & | sameVal,
|  | std::vector< Bool > & | allSame,
|  | const DataIterator & | dataBegin,
|  | const WeightsIterator & | weightBegin,
|  | uInt64 | nr,
|  | uInt | dataStride,
|  | const MaskIterator & | maskBegin,
|  | uInt | maskStride,
|  | const std::vector< StatsHistogram< AccumType > > & | binDesc,
|  | const std::vector< AccumType > & | maxLimit ) const

protected virtual

## _findBins() [2/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>

virtual void casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >::_findBins | ( | std::vector< BinCountArray > & | binCounts,
|  | std::vector< std::shared_ptr< AccumType > > & | sameVal,
|  | std::vector< Bool > & | allSame,
|  | const DataIterator & | dataBegin,
|  | const WeightsIterator & | weightsBegin,
|  | uInt64 | nr,
|  | uInt | dataStride,
|  | const DataRanges & | ranges,
|  | Bool | isInclude,
|  | const std::vector< StatsHistogram< AccumType > > & | binDesc,
|  | const std::vector< AccumType > & | maxLimit ) const

protected virtual

References DataRanges.

## _findBins() [3/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>

virtual void casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >::_findBins | ( | std::vector< BinCountArray > & | binCounts,
|  | std::vector< std::shared_ptr< AccumType > > & | sameVal,
|  | std::vector< Bool > & | allSame,
|  | const DataIterator & | dataBegin,
|  | const WeightsIterator & | weightsBegin,
|  | uInt64 | nr,
|  | uInt | dataStride,
|  | const MaskIterator & | maskBegin,
|  | uInt | maskStride,
|  | const DataRanges & | ranges,
|  | Bool | isInclude,
|  | const std::vector< StatsHistogram< AccumType > > & | binDesc,
|  | const std::vector< AccumType > & | maxLimit ) const

protected virtual

References DataRanges.

## _findBins() [4/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>

virtual void casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >::_findBins | ( | std::vector< BinCountArray > & | binCounts,
|  | std::vector< std::shared_ptr< AccumType > > & | sameVal,
|  | std::vector< Bool > & | allSame,
|  | const DataIterator & | dataBegin,
|  | const WeightsIterator & | weightsBegin,
|  | uInt64 | nr,
|  | uInt | dataStride,
|  | const std::vector< StatsHistogram< AccumType > > & | binDesc,
|  | const std::vector< AccumType > & | maxLimit ) const

protected virtual

## _findBins() [5/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>

virtual void casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >::_findBins | ( | std::vector< BinCountArray > & | binCounts,
|  | std::vector< std::shared_ptr< AccumType > > & | sameVal,
|  | std::vector< Bool > & | allSame,
|  | const DataIterator & | dataBegin,
|  | uInt64 | nr,
|  | uInt | dataStride,
|  | const DataRanges & | ranges,
|  | Bool | isInclude,
|  | const std::vector< StatsHistogram< AccumType > > & | binDesc,
|  | const std::vector< AccumType > & | maxLimit ) const

protected virtual

References DataRanges.

## _findBins() [6/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>

virtual void casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >::_findBins | ( | std::vector< BinCountArray > & | binCounts,
|  | std::vector< std::shared_ptr< AccumType > > & | sameVal,
|  | std::vector< Bool > & | allSame,
|  | const DataIterator & | dataBegin,
|  | uInt64 | nr,
|  | uInt | dataStride,
|  | const MaskIterator & | maskBegin,
|  | uInt | maskStride,
|  | const DataRanges & | ranges,
|  | Bool | isInclude,
|  | const std::vector< StatsHistogram< AccumType > > & | binDesc,
|  | const std::vector< AccumType > & | maxLimit ) const

protected virtual

References DataRanges.

## _findBins() [7/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>

virtual void casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >::_findBins | ( | std::vector< BinCountArray > & | binCounts,
|  | std::vector< std::shared_ptr< AccumType > > & | sameVal,
|  | std::vector< Bool > & | allSame,
|  | const DataIterator & | dataBegin,
|  | uInt64 | nr,
|  | uInt | dataStride,
|  | const MaskIterator & | maskBegin,
|  | uInt | maskStride,
|  | const std::vector< StatsHistogram< AccumType > > & | binDesc,
|  | const std::vector< AccumType > & | maxLimit ) const

protected virtual

## _findBins() [8/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>

virtual void casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >::_findBins | ( | std::vector< BinCountArray > & | binCounts,
|  | std::vector< std::shared_ptr< AccumType > > & | sameVal,
|  | std::vector< Bool > & | allSame,
|  | const DataIterator & | dataBegin,
|  | uInt64 | nr,
|  | uInt | dataStride,
|  | const std::vector< StatsHistogram< AccumType > > & | binDesc,
|  | const std::vector< AccumType > & | maxLimit ) const

protected virtual

## _populateArray() [1/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>

virtual void casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >::_populateArray | ( | DataArray & | ary,
|  | const DataIterator & | dataBegin,
|  | const WeightsIterator & | weightBegin,
|  | uInt64 | nr,
|  | uInt | dataStride,
|  | const MaskIterator & | maskBegin,
|  | uInt | maskStride ) const

protected virtual

weights and mask

References DataArray.

## _populateArray() [2/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>

virtual void casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >::_populateArray | ( | DataArray & | ary,
|  | const DataIterator & | dataBegin,
|  | const WeightsIterator & | weightBegin,
|  | uInt64 | nr,
|  | uInt | dataStride,
|  | const MaskIterator & | maskBegin,
|  | uInt | maskStride,
|  | const DataRanges & | ranges,
|  | Bool | isInclude ) const

protected virtual

weights, mask, ranges

References DataArray, and DataRanges.

## _populateArray() [3/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>

virtual void casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >::_populateArray | ( | DataArray & | ary,
|  | const DataIterator & | dataBegin,
|  | const WeightsIterator & | weightsBegin,
|  | uInt64 | nr,
|  | uInt | dataStride ) const

protected virtual

weights

References DataArray.

## _populateArray() [4/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>

virtual void casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >::_populateArray | ( | DataArray & | ary,
|  | const DataIterator & | dataBegin,
|  | const WeightsIterator & | weightsBegin,
|  | uInt64 | nr,
|  | uInt | dataStride,
|  | const DataRanges & | ranges,
|  | Bool | isInclude ) const

protected virtual

weights and ranges

References DataArray, and DataRanges.

## _populateArray() [5/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>

virtual void casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >::_populateArray | ( | DataArray & | ary,
|  | const DataIterator & | dataBegin,
|  | uInt64 | nr,
|  | uInt | dataStride ) const

protected virtual

populate an unsorted array with valid data.

If includeLimits is defined, then restrict values that are entered in the array to those limits (inclusive of the minimum, exclusive of the maximum). maxCount and currentCount are used only if includeLimits is defined. In this case, the method will return when currentCount == maxCount, thus avoiding scanning remaining data unnecessarily.

no weights, no mask, no ranges

Reimplemented from casacore::ConstrainedRangeQuantileComputer< CASA_STATP >.

References DataArray.

## _populateArray() [6/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>

virtual void casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >::_populateArray | ( | DataArray & | ary,
|  | const DataIterator & | dataBegin,
|  | uInt64 | nr,
|  | uInt | dataStride,
|  | const DataRanges & | ranges,
|  | Bool | isInclude ) const

protected virtual

ranges

References DataArray, and DataRanges.

## _populateArray() [7/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>

virtual void casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >::_populateArray | ( | DataArray & | ary,
|  | const DataIterator & | dataBegin,
|  | uInt64 | nr,
|  | uInt | dataStride,
|  | const MaskIterator & | maskBegin,
|  | uInt | maskStride ) const

protected virtual

References DataArray.

## _populateArray() [8/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>

virtual void casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >::_populateArray | ( | DataArray & | ary,
|  | const DataIterator & | dataBegin,
|  | uInt64 | nr,
|  | uInt | dataStride,
|  | const MaskIterator & | maskBegin,
|  | uInt | maskStride,
|  | const DataRanges & | ranges,
|  | Bool | isInclude ) const

protected virtual

mask and ranges

References DataArray, and DataRanges.

## _populateArrays() [1/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>

virtual void casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >::_populateArrays | ( | std::vector< DataArray > & | arys,
|  | uInt64 & | currentCount,
|  | const DataIterator & | dataBegin,
|  | const WeightsIterator & | weightBegin,
|  | uInt64 | nr,
|  | uInt | dataStride,
|  | const MaskIterator & | maskBegin,
|  | uInt | maskStride,
|  | const DataRanges & | ranges,
|  | Bool | isInclude,
|  | const IncludeLimits & | includeLimits,
|  | uInt64 | maxCount ) const

protected virtual

weights, mask, ranges

References DataRanges, and IncludeLimits.

## _populateArrays() [2/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>

virtual void casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >::_populateArrays | ( | std::vector< DataArray > & | arys,
|  | uInt64 & | currentCount,
|  | const DataIterator & | dataBegin,
|  | const WeightsIterator & | weightBegin,
|  | uInt64 | nr,
|  | uInt | dataStride,
|  | const MaskIterator & | maskBegin,
|  | uInt | maskStride,
|  | const IncludeLimits & | includeLimits,
|  | uInt64 | maxCount ) const

protected virtual

weights and mask

References IncludeLimits.

## _populateArrays() [3/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>

virtual void casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >::_populateArrays | ( | std::vector< DataArray > & | arys,
|  | uInt64 & | currentCount,
|  | const DataIterator & | dataBegin,
|  | const WeightsIterator & | weightsBegin,
|  | uInt64 | nr,
|  | uInt | dataStride,
|  | const DataRanges & | ranges,
|  | Bool | isInclude,
|  | const IncludeLimits & | includeLimits,
|  | uInt64 | maxCount ) const

protected virtual

weights and ranges

References DataRanges, and IncludeLimits.

## _populateArrays() [4/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>

virtual void casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >::_populateArrays | ( | std::vector< DataArray > & | arys,
|  | uInt64 & | currentCount,
|  | const DataIterator & | dataBegin,
|  | const WeightsIterator & | weightsBegin,
|  | uInt64 | nr,
|  | uInt | dataStride,
|  | const IncludeLimits & | includeLimits,
|  | uInt64 | maxCount ) const

protected virtual

weights

References IncludeLimits.

## _populateArrays() [5/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>

virtual void casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >::_populateArrays | ( | std::vector< DataArray > & | arys,
|  | uInt64 & | currentCount,
|  | const DataIterator & | dataBegin,
|  | uInt64 | nr,
|  | uInt | dataStride,
|  | const DataRanges & | ranges,
|  | Bool | isInclude,
|  | const IncludeLimits & | includeLimits,
|  | uInt64 | maxCount ) const

protected virtual

ranges

References DataRanges, and IncludeLimits.

## _populateArrays() [6/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>

virtual void casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >::_populateArrays | ( | std::vector< DataArray > & | arys,
|  | uInt64 & | currentCount,
|  | const DataIterator & | dataBegin,
|  | uInt64 | nr,
|  | uInt | dataStride,
|  | const IncludeLimits & | includeLimits,
|  | uInt64 | maxCount ) const

protected virtual

no weights, no mask, no ranges

Reimplemented from casacore::ConstrainedRangeQuantileComputer< CASA_STATP >.

References IncludeLimits.

## _populateArrays() [7/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>

virtual void casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >::_populateArrays | ( | std::vector< DataArray > & | arys,
|  | uInt64 & | currentCount,
|  | const DataIterator & | dataBegin,
|  | uInt64 | nr,
|  | uInt | dataStride,
|  | const MaskIterator & | maskBegin,
|  | uInt | maskStride,
|  | const DataRanges & | ranges,
|  | Bool | isInclude,
|  | const IncludeLimits & | includeLimits,
|  | uInt64 | maxCount ) const

protected virtual

mask and ranges

References DataRanges, and IncludeLimits.

## _populateArrays() [8/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>

virtual void casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >::_populateArrays | ( | std::vector< DataArray > & | arys,
|  | uInt64 & | currentCount,
|  | const DataIterator & | dataBegin,
|  | uInt64 | nr,
|  | uInt | dataStride,
|  | const MaskIterator & | maskBegin,
|  | uInt | maskStride,
|  | const IncludeLimits & | includeLimits,
|  | uInt64 | maxCount ) const

protected virtual

References IncludeLimits.

## _populateTestArray() [1/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>

virtual Bool casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >::_populateTestArray | ( | DataArray & | ary,
|  | const DataIterator & | dataBegin,
|  | const WeightsIterator & | weightBegin,
|  | uInt64 | nr,
|  | uInt | dataStride,
|  | const MaskIterator & | maskBegin,
|  | uInt | maskStride,
|  | const DataRanges & | ranges,
|  | Bool | isInclude,
|  | uInt | maxElements ) const

protected virtual

weights, mask, ranges

References DataArray, and DataRanges.

## _populateTestArray() [2/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>

virtual Bool casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >::_populateTestArray | ( | DataArray & | ary,
|  | const DataIterator & | dataBegin,
|  | const WeightsIterator & | weightBegin,
|  | uInt64 | nr,
|  | uInt | dataStride,
|  | const MaskIterator & | maskBegin,
|  | uInt | maskStride,
|  | uInt | maxElements ) const

protected virtual

weights and mask

References DataArray.

## _populateTestArray() [3/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>

virtual Bool casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >::_populateTestArray | ( | DataArray & | ary,
|  | const DataIterator & | dataBegin,
|  | const WeightsIterator & | weightBegin,
|  | uInt64 | nr,
|  | uInt | dataStride,
|  | uInt | maxElements ) const

protected virtual

weights

References DataArray.

## _populateTestArray() [4/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>

virtual Bool casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >::_populateTestArray | ( | DataArray & | ary,
|  | const DataIterator & | dataBegin,
|  | const WeightsIterator & | weightsBegin,
|  | uInt64 | nr,
|  | uInt | dataStride,
|  | const DataRanges & | ranges,
|  | Bool | isInclude,
|  | uInt | maxElements ) const

protected virtual

weights and ranges

References DataArray, and DataRanges.

## _populateTestArray() [5/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>

virtual Bool casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >::_populateTestArray | ( | DataArray & | ary,
|  | const DataIterator & | dataBegin,
|  | uInt64 | nr,
|  | uInt | dataStride,
|  | const DataRanges & | ranges,
|  | Bool | isInclude,
|  | uInt | maxElements ) const

protected virtual

ranges

References DataArray, and DataRanges.

## _populateTestArray() [6/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>

virtual Bool casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >::_populateTestArray | ( | DataArray & | ary,
|  | const DataIterator & | dataBegin,
|  | uInt64 | nr,
|  | uInt | dataStride,
|  | const MaskIterator & | maskBegin,
|  | uInt | maskStride,
|  | const DataRanges & | ranges,
|  | Bool | isInclude,
|  | uInt | maxElements ) const

protected virtual

mask and ranges

References DataArray, and DataRanges.

## _populateTestArray() [7/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>

virtual Bool casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >::_populateTestArray | ( | DataArray & | ary,
|  | const DataIterator & | dataBegin,
|  | uInt64 | nr,
|  | uInt | dataStride,
|  | const MaskIterator & | maskBegin,
|  | uInt | maskStride,
|  | uInt | maxElements ) const

protected virtual

mask

References DataArray.

## _populateTestArray() [8/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>

virtual Bool casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >::_populateTestArray | ( | DataArray & | ary,
|  | const DataIterator & | dataBegin,
|  | uInt64 | nr,
|  | uInt | dataStride,
|  | uInt | maxElements ) const

protected virtual

no weights, no mask, no ranges

Reimplemented from casacore::ConstrainedRangeQuantileComputer< CASA_STATP >.

References DataArray.

## clone()

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>

virtual StatisticsAlgorithmQuantileComputer< CASA_STATP > * casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >::clone | ( |  | ) | const

virtual

clone this object by returning a pointer to a copy

Reimplemented from casacore::ConstrainedRangeQuantileComputer< CASA_STATP >.

## operator=()

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>

HingesFencesQuantileComputer & casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >::operator= | ( | const HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator > & | other | ) |

copy semantics

References HingesFencesQuantileComputer().

## reset()

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>

virtual void casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >::reset | ( |  | ) |

virtual

reset private fields

Reimplemented from casacore::ClassicalQuantileComputer< CASA_STATP >.

## setHasRange()

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>

void casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >::setHasRange | ( | Bool | hr | ) |

inline

Definition at line 70 of file HingesFencesQuantileComputer.h.

References _hasRange.

## Member Data Documentation

## _hasRange

template<class AccumType, class DataIterator, class MaskIterator = const Bool*, class WeightsIterator = DataIterator>

Bool casacore::HingesFencesQuantileComputer< AccumType, DataIterator, MaskIterator, WeightsIterator >::_hasRange

private

Definition at line 336 of file HingesFencesQuantileComputer.h.

Referenced by setHasRange().

The documentation for this class was generated from the following file:

- scimath/StatsFramework/HingesFencesQuantileComputer.h